{*******************************************************}
{        VV_lib (vvTreeView)                            }
{        Copyright (c) 1999                             }
{          Vladimir Kuznetsov  (kuzn_vv@mail.ru)        }
{*******************************************************}
unit vvTreeView;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, VCLUtils;

Type
  TTreeItemDblClickEvent = procedure (Sender: TObject; Node: TTreeNode) of object;

  TvvTreeView = class(TTreeView)
   private
     FOnTreeItemDblClick : TTreeItemDblClickEvent;
     procedure WMLButtonDblClk( var Message: TWMLButtonDblClk ); message WM_LBUTTONDBLCLK;
     procedure WMRButtonDown( var Message: TWMRButtonDown ); message WM_RBUTTONDOWN;
   published
     property OnTreeItemDblClick : TTreeItemDblClickEvent read FOnTreeItemDblClick write FOnTreeItemDblClick;
   end;

procedure Register;

implementation

procedure TvvTreeView.WMRButtonDown( var Message: TWMRButtonDown );
var
  clicNode : TTreeNode;
begin
  clicNode := GetNodeAt(Message.XPos, Message.YPos);
  if clicNode<>nil then
    Selected := clicNode;
  inherited;
end;

procedure TvvTreeView.WMLButtonDblClk( var Message: TWMLButtonDblClk );
var
  ClickPt: TPoint;
  SelRect : TRect;
begin
  SelRect := Selected.DisplayRect(True);
  ClickPt.X := Message.XPos;
  ClickPt.Y := Message.YPos;
  if PointInRect(ClickPt, SelRect) then
    begin
    if assigned(FOnTreeItemDblClick) then
      FOnTreeItemDblClick(Self, Selected);
    end
  else
    inherited;
end;

procedure Register;
begin
  RegisterComponents('vv_lib', [TvvTreeView]);
end;

end.
