{+-----------------------------------------------------------------------------+
 | Class:       TvvSqlSyn
 | Description: NEW SQL syntax highliter
 |              More compatible with MSSQL 7.0
 |              New token kind - Parametr - like Delphi TQuery parametrs
 |              Compatible with Exporters
 | Last change: 1999-10-25
 | Author:      Vladimir Kuznetsov (kuzn_vv@mail.ru)
 |              Based on Willo van der Merwe [willow@billcad.co.za] highliter
 | Version:     0.1
 | No rights reserved.
 | Thanks to: Primoz Gabrijelcic and Martin Waldenburg
 +----------------------------------------------------------------------------+}

unit vvSQLSyn;

interface

uses
  SysUtils, Windows, Messages, Classes, Controls, Graphics, Registry, mwHighlighter, mwExport, mwLocalStr;

var
  Identifiers: array[#0..#255] of ByteBool;
  mHashTable: array[#0..#255] of Integer;

Type
  TtkTokenKind = (
    tkComment,
    tkIdentifier,
    tkKey,
    tkNull,
    tkNumber,
    tkParametr,  //kuzn_vv
    tkMacros,    //kuzn_vv
    tkIllegal,  //kuzn_vv
    tkSpace,
    tkString,
    tkSymbol,
    tkUnknown);

  TRangeState = (rsANil, rsAnsiC, rsMacrosInStr, rsEndStrAfterMacr, rsUnKnown); //kuzn_vv rsANil, rsAnsiC, rsUnKnown

  TProcTableProc = procedure of Object;

  TIdentFuncTableFunc = function: TtkTokenKind of Object;

type
  TvvSqlSyn = class(TmwCustomHighLighter)
  private
    fRange: TRangeState;
    fLine: PChar;
    fLineNumber: Integer;
    fProcTable: array[#0..#255] of TProcTableProc;
    Run: LongInt;
    fStringLen: Integer;
    fToIdent: PChar;
    fTokenPos: Integer;
    FTokenID: TtkTokenKind;
    fIdentFuncTable: array[0..265] of TIdentFuncTableFunc;
    fCommentAttri: TmwHighLightAttributes;
    fIdentifierAttri: TmwHighLightAttributes;
    fKeyAttri: TmwHighLightAttributes;
    fNumberAttri: TmwHighLightAttributes;
    fParametrAttri: TmwHighLightAttributes;
    fMacrosAttri: TmwHighLightAttributes;
    fIllegalAttri: TmwHighLightAttributes;
    fSpaceAttri: TmwHighLightAttributes;
    fStringAttri: TmwHighLightAttributes;
    fSymbolAttri: TmwHighLightAttributes;
    function KeyHash(ToHash: PChar): Integer;
    function KeyComp(const aKey: String): Boolean;
    function Func9:TtkTokenKind;
    function Func12:TtkTokenKind;
    function Func15:TtkTokenKind;
    function Func19:TtkTokenKind;
    function Func20:TtkTokenKind;
    function Func21:TtkTokenKind;
    function Func22:TtkTokenKind;
    function Func23:TtkTokenKind;
    function Func25:TtkTokenKind;
    function Func27:TtkTokenKind;
    function Func28:TtkTokenKind;
    function Func29:TtkTokenKind;
    function Func30:TtkTokenKind;
    function Func31:TtkTokenKind;
    function Func32:TtkTokenKind;
    function Func33:TtkTokenKind;
    function Func34:TtkTokenKind;
    function Func35:TtkTokenKind;
    function Func36:TtkTokenKind;
    function Func37:TtkTokenKind;
    function Func38:TtkTokenKind;
    function Func39:TtkTokenKind;
    function Func40:TtkTokenKind;
    function Func41:TtkTokenKind;
    function Func42:TtkTokenKind;
    function Func43:TtkTokenKind;
    function Func44:TtkTokenKind;
    function Func45:TtkTokenKind;
    function Func46:TtkTokenKind;
    function Func47:TtkTokenKind;
    function Func48:TtkTokenKind;
    function Func49:TtkTokenKind;
    function Func50:TtkTokenKind;
    function Func51:TtkTokenKind;
    function Func52:TtkTokenKind;
    function Func53:TtkTokenKind;
    function Func54:TtkTokenKind;
    function Func55:TtkTokenKind;
    function Func56:TtkTokenKind;
    function Func57:TtkTokenKind;
    function Func58:TtkTokenKind;
    function Func59:TtkTokenKind;
    function Func60:TtkTokenKind;
    function Func61:TtkTokenKind;
    function Func62:TtkTokenKind;
    function Func63:TtkTokenKind;
    function Func64:TtkTokenKind;
    function Func65:TtkTokenKind;
    function Func66:TtkTokenKind;
    function Func67:TtkTokenKind;
    function Func68:TtkTokenKind;
    function Func69:TtkTokenKind;
    function Func70:TtkTokenKind;
    function Func71:TtkTokenKind;
    function Func72:TtkTokenKind;
    function Func73:TtkTokenKind;
    function Func74:TtkTokenKind;
    function Func75:TtkTokenKind;
    function Func76:TtkTokenKind;
    function Func77:TtkTokenKind;
    function Func78:TtkTokenKind;
    function Func79:TtkTokenKind;
    function Func80:TtkTokenKind;
    function Func81:TtkTokenKind;
    function Func82:TtkTokenKind;
    function Func83:TtkTokenKind;
    function Func84:TtkTokenKind;
    function Func85:TtkTokenKind;
    function Func86:TtkTokenKind;
    function Func87:TtkTokenKind;
    function Func89:TtkTokenKind;
    function Func90:TtkTokenKind;
    function Func91:TtkTokenKind;
    function Func92:TtkTokenKind;
    function Func93:TtkTokenKind;
    function Func94:TtkTokenKind;
    function Func95:TtkTokenKind;
    function Func96:TtkTokenKind;
    function Func97:TtkTokenKind;
    function Func98:TtkTokenKind;
    function Func99:TtkTokenKind;
    function Func100:TtkTokenKind;
    function Func101:TtkTokenKind;
    function Func102:TtkTokenKind;
    function Func103:TtkTokenKind;
    function Func104:TtkTokenKind;
    function Func105:TtkTokenKind;
    function Func106:TtkTokenKind;
    function Func107:TtkTokenKind;
    function Func108:TtkTokenKind;
    function Func109:TtkTokenKind;
    function Func110:TtkTokenKind;
    function Func111:TtkTokenKind;
    function Func112:TtkTokenKind;
    function Func113:TtkTokenKind;
    function Func114:TtkTokenKind;
    function Func115:TtkTokenKind;
    function Func116:TtkTokenKind;
    function Func117:TtkTokenKind;
    function Func118:TtkTokenKind;
    function Func119:TtkTokenKind;
    function Func120:TtkTokenKind;
    function Func122:TtkTokenKind;
    function Func123:TtkTokenKind;
    function Func126:TtkTokenKind;
    function Func127:TtkTokenKind;
    function Func128:TtkTokenKind;
    function Func129:TtkTokenKind;
    function Func131:TtkTokenKind;
    function Func133:TtkTokenKind;
    function Func134:TtkTokenKind;
    function Func137:TtkTokenKind;
    function Func138:TtkTokenKind;
    function Func139:TtkTokenKind;
    function Func141:TtkTokenKind;
    function Func143:TtkTokenKind;
    function Func150:TtkTokenKind;
    function Func152:TtkTokenKind;
    function Func157:TtkTokenKind;
    function Func160:TtkTokenKind;
    function Func167:TtkTokenKind;
    function Func173:TtkTokenKind;
    function Func174:TtkTokenKind;
    function Func177:TtkTokenKind;
    function Func180:TtkTokenKind;
    function Func181:TtkTokenKind;
    function Func182:TtkTokenKind;
    function Func184:TtkTokenKind;
    function Func187:TtkTokenKind;
    function Func190:TtkTokenKind;
    function Func192:TtkTokenKind;
    function Func193:TtkTokenKind;
    function Func194:TtkTokenKind;
    function Func195:TtkTokenKind;
    function Func196:TtkTokenKind;
    function Func197:TtkTokenKind;
    function Func200:TtkTokenKind;
    function Func208:TtkTokenKind;
    function Func210:TtkTokenKind;
    function Func212:TtkTokenKind;
    function Func213:TtkTokenKind;
    function Func214:TtkTokenKind;
    function Func215:TtkTokenKind;
    function Func220:TtkTokenKind;
    function Func221:TtkTokenKind;
    function Func224:TtkTokenKind;
    function Func226:TtkTokenKind;
    function Func232:TtkTokenKind;
    function Func235:TtkTokenKind;
    function Func237:TtkTokenKind;
    function Func244:TtkTokenKind;
    function Func246:TtkTokenKind;
    function Func265:TtkTokenKind;
    procedure AmpersandProc;
    procedure BraceCloseProc;
    procedure BraceOpenProc;
    procedure CRProc;
    procedure ColonProc;
    procedure CommaProc;
    procedure EqualProc;
    procedure ExponentiationProc;
    procedure GreaterProc;
    procedure IdentProc;
    procedure LFProc;
    procedure LowerProc;
    procedure MinusProc;
    procedure NullProc;
    procedure NumberProc;
    procedure PercentProc;
    procedure PipeProc;
    procedure PlusProc;
    procedure PointProc;
    procedure QuestionProc;
    procedure RoundCloseProc;
    procedure RoundOpenProc;
    procedure SemiColonProc;
    procedure SlashProc;
    procedure SpaceProc;
    procedure StarProc;
    procedure StringProc;
    procedure UnknownProc;
    function AltFunc: TtkTokenKind;
    procedure InitIdent;
    function IdentKind(MayBe: PChar): TtkTokenKind;
    procedure MakeMethodTables;
    procedure AnsiCProc;  //kuzn_vv
    procedure MacrosProc; //kuzn_vv
    procedure EndStrAfterMacros;  //kuzn_vv
  protected
    function GetIdentChars: TIdentChars; override;
    function GetLanguageName: string; override;
    function GetCapability: THighlighterCapability; override;
  public
    constructor Create(AOwner: TComponent); override;
    function GetEOL: Boolean; override;
    function GetRange: Pointer; override;
    function GetTokenID: TtkTokenKind;
    procedure SetLine(NewValue: String; LineNumber: Integer); override;
    procedure ExportNext; override;
    procedure SetLineForExport(NewValue: String); override;
    function GetToken: String; override;
    function GetTokenAttribute: TmwHighLightAttributes; override;
    function GetTokenKind: integer; override;
    function GetTokenPos: Integer; override;
    procedure Next; override;
    procedure SetRange(Value: Pointer); override;
    procedure ReSetRange; override;
    property IdentChars;
  published
    property CommentAttri: TmwHighLightAttributes read fCommentAttri write fCommentAttri;
    property IdentifierAttri: TmwHighLightAttributes read fIdentifierAttri write fIdentifierAttri;
    property KeyAttri: TmwHighLightAttributes read fKeyAttri write fKeyAttri;
    property NumberAttri: TmwHighLightAttributes read fNumberAttri write fNumberAttri;
    property ParametrAttri: TmwHighLightAttributes read fParametrAttri write fParametrAttri;
    property MacrosAttri: TmwHighLightAttributes read fMacrosAttri write fMacrosAttri;
    property IllegalAttri: TmwHighLightAttributes read fIllegalAttri write fIllegalAttri;
    property SpaceAttri: TmwHighLightAttributes read fSpaceAttri write fSpaceAttri;
    property StringAttri: TmwHighLightAttributes read fStringAttri write fStringAttri;
    property SymbolAttri: TmwHighLightAttributes read fSymbolAttri write fSymbolAttri;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('vv_mwEdit', [TvvSqlSyn]);
end;

procedure MakeIdentTable;
var
  I, J: Char;
begin
  for I := #0 to #255 do
  begin
    Case I of
      '_', '0'..'9', 'a'..'z', 'A'..'Z': Identifiers[I] := True;
    else Identifiers[I] := False;
    end;
    J := UpperCase(I)[1];
    Case I in ['_', 'A'..'Z', 'a'..'z'] of
      True: mHashTable[I] := Ord(J) - 64
    else mHashTable[I] := 0;
    end;
  end;
end;

procedure TvvSqlSyn.InitIdent;
var
  I: Integer;
  pF: ^TIdentFuncTableFunc;
begin
  pF := @fIdentFuncTable;
  for I := Low(fIdentFuncTable) to High(fIdentFuncTable) do begin
    pF^ := AltFunc;
    Inc(pF);
  end;
  fIdentFuncTable[9] := Func9;
  fIdentFuncTable[12] := Func12;
  fIdentFuncTable[15] := Func15;
  fIdentFuncTable[19] := Func19;
  fIdentFuncTable[20] := Func20;
  fIdentFuncTable[21] := Func21;
  fIdentFuncTable[22] := Func22;
  fIdentFuncTable[23] := Func23;
  fIdentFuncTable[25] := Func25;
  fIdentFuncTable[27] := Func27;
  fIdentFuncTable[28] := Func28;
  fIdentFuncTable[29] := Func29;
  fIdentFuncTable[30] := Func30;
  fIdentFuncTable[31] := Func31;
  fIdentFuncTable[32] := Func32;
  fIdentFuncTable[33] := Func33;
  fIdentFuncTable[34] := Func34;
  fIdentFuncTable[35] := Func35;
  fIdentFuncTable[36] := Func36;
  fIdentFuncTable[37] := Func37;
  fIdentFuncTable[38] := Func38;
  fIdentFuncTable[39] := Func39;
  fIdentFuncTable[40] := Func40;
  fIdentFuncTable[41] := Func41;
  fIdentFuncTable[42] := Func42;
  fIdentFuncTable[43] := Func43;
  fIdentFuncTable[44] := Func44;
  fIdentFuncTable[45] := Func45;
  fIdentFuncTable[46] := Func46;
  fIdentFuncTable[47] := Func47;
  fIdentFuncTable[48] := Func48;
  fIdentFuncTable[49] := Func49;
  fIdentFuncTable[50] := Func50;
  fIdentFuncTable[51] := Func51;
  fIdentFuncTable[52] := Func52;
  fIdentFuncTable[53] := Func53;
  fIdentFuncTable[54] := Func54;
  fIdentFuncTable[55] := Func55;
  fIdentFuncTable[56] := Func56;
  fIdentFuncTable[57] := Func57;
  fIdentFuncTable[58] := Func58;
  fIdentFuncTable[59] := Func59;
  fIdentFuncTable[60] := Func60;
  fIdentFuncTable[61] := Func61;
  fIdentFuncTable[62] := Func62;
  fIdentFuncTable[63] := Func63;
  fIdentFuncTable[64] := Func64;
  fIdentFuncTable[65] := Func65;
  fIdentFuncTable[66] := Func66;
  fIdentFuncTable[67] := Func67;
  fIdentFuncTable[68] := Func68;
  fIdentFuncTable[69] := Func69;
  fIdentFuncTable[70] := Func70;
  fIdentFuncTable[71] := Func71;
  fIdentFuncTable[72] := Func72;
  fIdentFuncTable[73] := Func73;
  fIdentFuncTable[74] := Func74;
  fIdentFuncTable[75] := Func75;
  fIdentFuncTable[76] := Func76;
  fIdentFuncTable[77] := Func77;
  fIdentFuncTable[78] := Func78;
  fIdentFuncTable[79] := Func79;
  fIdentFuncTable[80] := Func80;
  fIdentFuncTable[81] := Func81;
  fIdentFuncTable[82] := Func82;
  fIdentFuncTable[83] := Func83;
  fIdentFuncTable[84] := Func84;
  fIdentFuncTable[85] := Func85;
  fIdentFuncTable[86] := Func86;
  fIdentFuncTable[87] := Func87;
  fIdentFuncTable[89] := Func89;
  fIdentFuncTable[90] := Func90;
  fIdentFuncTable[91] := Func91;
  fIdentFuncTable[92] := Func92;
  fIdentFuncTable[93] := Func93;
  fIdentFuncTable[94] := Func94;
  fIdentFuncTable[95] := Func95;
  fIdentFuncTable[96] := Func96;
  fIdentFuncTable[97] := Func97;
  fIdentFuncTable[98] := Func98;
  fIdentFuncTable[99] := Func99;
  fIdentFuncTable[100] := Func100;
  fIdentFuncTable[101] := Func101;
  fIdentFuncTable[102] := Func102;
  fIdentFuncTable[103] := Func103;
  fIdentFuncTable[104] := Func104;
  fIdentFuncTable[105] := Func105;
  fIdentFuncTable[106] := Func106;
  fIdentFuncTable[107] := Func107;
  fIdentFuncTable[108] := Func108;
  fIdentFuncTable[109] := Func109;
  fIdentFuncTable[110] := Func110;
  fIdentFuncTable[111] := Func111;
  fIdentFuncTable[112] := Func112;
  fIdentFuncTable[113] := Func113;
  fIdentFuncTable[114] := Func114;
  fIdentFuncTable[115] := Func115;
  fIdentFuncTable[116] := Func116;
  fIdentFuncTable[117] := Func117;
  fIdentFuncTable[118] := Func118;
  fIdentFuncTable[119] := Func119;
  fIdentFuncTable[120] := Func120;
  fIdentFuncTable[122] := Func122;
  fIdentFuncTable[123] := Func123;
  fIdentFuncTable[126] := Func126;
  fIdentFuncTable[127] := Func127;
  fIdentFuncTable[128] := Func128;
  fIdentFuncTable[129] := Func129;
  fIdentFuncTable[131] := Func131;
  fIdentFuncTable[133] := Func133;
  fIdentFuncTable[134] := Func134;
  fIdentFuncTable[137] := Func137;
  fIdentFuncTable[138] := Func138;
  fIdentFuncTable[139] := Func139;
  fIdentFuncTable[141] := Func141;
  fIdentFuncTable[143] := Func143;
  fIdentFuncTable[150] := Func150;
  fIdentFuncTable[152] := Func152;
  fIdentFuncTable[157] := Func157;
  fIdentFuncTable[160] := Func160;
  fIdentFuncTable[167] := Func167;
  fIdentFuncTable[173] := Func173;
  fIdentFuncTable[174] := Func174;
  fIdentFuncTable[177] := Func177;
  fIdentFuncTable[180] := Func180;
  fIdentFuncTable[181] := Func181;
  fIdentFuncTable[182] := Func182;
  fIdentFuncTable[184] := Func184;
  fIdentFuncTable[187] := Func187;
  fIdentFuncTable[190] := Func190;
  fIdentFuncTable[192] := Func192;
  fIdentFuncTable[193] := Func193;
  fIdentFuncTable[194] := Func194;
  fIdentFuncTable[195] := Func195;
  fIdentFuncTable[196] := Func196;
  fIdentFuncTable[197] := Func197;
  fIdentFuncTable[200] := Func200;
  fIdentFuncTable[208] := Func208;
  fIdentFuncTable[210] := Func210;
  fIdentFuncTable[212] := Func212;
  fIdentFuncTable[213] := Func213;
  fIdentFuncTable[214] := Func214;
  fIdentFuncTable[215] := Func215;
  fIdentFuncTable[220] := Func220;
  fIdentFuncTable[221] := Func221;
  fIdentFuncTable[224] := Func224;
  fIdentFuncTable[226] := Func226;
  fIdentFuncTable[232] := Func232;
  fIdentFuncTable[235] := Func235;
  fIdentFuncTable[237] := Func237;
  fIdentFuncTable[244] := Func244;
  fIdentFuncTable[246] := Func246;
  fIdentFuncTable[265] := Func265;
end;

function TvvSqlSyn.KeyHash(ToHash: PChar): Integer;
begin
  Result := 0;
  while ToHash^ in ['_', '0'..'9', 'a'..'z', 'A'..'Z'] do
  begin
    inc(Result, mHashTable[ToHash^]);
    inc(ToHash);
  end;
  fStringLen := ToHash - fToIdent;
end;

function TvvSqlSyn.KeyComp(const aKey: String): Boolean;
var
  I: Integer;
  Temp: PChar;
begin
  Temp := fToIdent;
  if Length(aKey) = fStringLen then
  begin
    Result := True;
    for i := 1 to fStringLen do
    begin
      if mHashTable[Temp^] <> mHashTable[aKey[i]] then
      begin
        Result := False;
        break;
      end;
      inc(Temp);
    end;
  end else Result := False;
end;

function TvvSqlSyn.Func9: TtkTokenKind;
begin
  if KeyComp('ADD') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func12: TtkTokenKind;
begin
  if KeyComp('DEC') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func15: TtkTokenKind;
begin
  if KeyComp('IF') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func19: TtkTokenKind;
begin
  if KeyComp('AND') then Result := tkKey else
    if KeyComp('DO') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func20: TtkTokenKind;
begin
  if KeyComp('CACHE') then Result := tkKey else
    if KeyComp('AS') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func21: TtkTokenKind;
begin
  if KeyComp('OF') then Result := tkKey else
    if KeyComp('AT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func22: TtkTokenKind;
begin
  if KeyComp('ABS') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func23: TtkTokenKind;
begin
  if KeyComp('IN') then Result := tkKey else
    if KeyComp('ASC') then Result := tkKey else
      if KeyComp('END') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func25: TtkTokenKind;
begin
  if KeyComp('ALL') then Result := tkKey else
    if KeyComp('PI') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func27: TtkTokenKind;
begin
  if KeyComp('BY') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func28: TtkTokenKind;
begin
  if KeyComp('IS') then Result := tkKey else
    if KeyComp('CALL') then Result := tkKey else
      if KeyComp('READ') then Result := tkKey else
        if KeyComp('CASE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func29: TtkTokenKind;
begin
  if KeyComp('ON') then Result := tkKey else
    if KeyComp('NO') then Result := tkKey else
      if KeyComp('CHR') then Result := tkKey else
        if KeyComp('PAGE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func30: TtkTokenKind;
begin
  if KeyComp('DAY') then Result := tkKey else
    if KeyComp('CHECK') then Result := tkKey else
      if KeyComp('CHAR') then Result := tkKey else
        if KeyComp('DATE') then Result := tkKey else
          if KeyComp('DATE') then Result := tkKey else
            if KeyComp('IDLE') then Result := tkKey else
              if KeyComp('AVG') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func31: TtkTokenKind;
begin
  if KeyComp('BLOB') then Result := tkKey else
    if KeyComp('BASED') then Result := tkKey else
      if KeyComp('DESC') then Result := tkKey else
        if KeyComp('BIT') then Result := tkKey else
          if KeyComp('ECHO') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func32: TtkTokenKind;
begin
  if KeyComp('CLOB') then Result := tkKey else
    if KeyComp('MOD') then Result := tkKey else
      if KeyComp('FILE') then Result := tkKey else
        if KeyComp('CLOB') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func33: TtkTokenKind;
begin
  if KeyComp('OR') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func34: TtkTokenKind;
begin
  if KeyComp('LOG10') then Result := tkKey else
    if KeyComp('LANG') then Result := tkKey else
      if KeyComp('LOG') then Result := tkKey else
        if KeyComp('BFILE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func35: TtkTokenKind;
begin
  if KeyComp('TO') then Result := tkKey else
    if KeyComp('TAN') then Result := tkKey else
      if KeyComp('IMAGE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func36: TtkTokenKind;
begin
  if KeyComp('MIN') then Result := tkKey else
    if KeyComp('ATAN2') then Result := tkKey else
      if KeyComp('DBDATE') then Result := tkKey else
        if KeyComp('REAL') then Result := tkKey else
          if KeyComp('CASCADE') then Result := tkKey else
            if KeyComp('ATAN') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func37: TtkTokenKind;
begin
  if KeyComp('EXEC') then Result := tkKey else
    if KeyComp('MODE') then Result := tkKey else
      if KeyComp('HEX') then Result := tkKey else
        if KeyComp('BEGIN') then Result := tkKey else
          if KeyComp('COS') then Result := tkKey else
            if KeyComp('LIKE') then Result := tkKey else
              if KeyComp('RAND') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func38: TtkTokenKind;
begin
  if KeyComp('EDIT') then Result := tkKey else
    if KeyComp('MAX') then Result := tkKey else
      if KeyComp('NODE') then Result := tkKey else
        if KeyComp('DBCLOB') then Result := tkKey else
          if KeyComp('ACOS') then Result := tkKey else
            if KeyComp('COT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func39: TtkTokenKind;
begin
  if KeyComp('LEV') then Result := tkKey else
    if KeyComp('FOR') then Result := tkKey else
      if KeyComp('DEBUG') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func40: TtkTokenKind;
begin
  if KeyComp('LCASE') then Result := tkKey else
    if KeyComp('TABLE') then Result := tkKey else
      if KeyComp('DBLANG') then Result := tkKey else
        if KeyComp('ANY') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func41: TtkTokenKind;
begin
  if KeyComp('ADMIN') then Result := tkKey else
    if KeyComp('ELSE') then Result := tkKey else
      if KeyComp('KEY') then Result := tkKey else
        if KeyComp('HELP') then Result := tkKey else
          if KeyComp('ASCII') then Result := tkKey else
            if KeyComp('GUID') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func42: TtkTokenKind;
begin
  if KeyComp('RAW') then Result := tkKey else
    if KeyComp('SIN') then Result := tkKey else
      if KeyComp('FETCH') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func43: TtkTokenKind;
begin
  if KeyComp('LEFT') then Result := tkKey else
    if KeyComp('CAST') then Result := tkKey else
      if KeyComp('TANH') then Result := tkKey else
        if KeyComp('ASIN') then Result := tkKey else
          if KeyComp('PLAN') then Result := tkKey else
            if KeyComp('INT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func44: TtkTokenKind;
begin
  if KeyComp('SET') then Result := tkKey else
    if KeyComp('WEEK') then Result := tkKey else
      if KeyComp('SPACE') then Result := tkKey else
        if KeyComp('NCHAR') then Result := tkKey else
          if KeyComp('DEGREE') then Result := tkKey else
            if KeyComp('DBEDIT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func45: TtkTokenKind;
begin
  if KeyComp('DBTS') then Result := tkKey else
    if KeyComp('PATH') then Result := tkKey else
      if KeyComp('EXP') then Result := tkKey else
        if KeyComp('COSH') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func46: TtkTokenKind;
begin
  if KeyComp('MEMO') then Result := tkKey else
    if KeyComp('NCLOB') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func47: TtkTokenKind;
begin
  if KeyComp('TIME') then Result := tkKey else
    if KeyComp('THEN') then Result := tkKey else
      if KeyComp('DECIMAL') then Result := tkKey else
        if KeyComp('LANGID') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func48: TtkTokenKind;
begin
  if KeyComp('JOIN') then Result := tkKey else
    if KeyComp('LONG') then Result := tkKey else
      if KeyComp('SQL') then Result := tkKey else
        if KeyComp('PAGES') then Result := tkKey else
          if KeyComp('DECLARE') then Result := tkKey else
            if KeyComp('MERGE') then Result := tkKey else
              if KeyComp('SPID') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func49: TtkTokenKind;
begin
  if KeyComp('NOT') then Result := tkKey else
    if KeyComp('SCHEMA') then Result := tkKey else
      if KeyComp('YEAR') then Result := tkKey else
        if KeyComp('ESCAPE') then Result := tkKey else
          if KeyComp('UCASE') then Result := tkKey else
            if KeyComp('DAYS') then Result := tkKey else
              if KeyComp('SIGN') then Result := tkKey else
                if KeyComp('GLOBAL') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func50: TtkTokenKind;
begin
  if KeyComp('OPEN') then Result := tkKey else
    if KeyComp('WHEN') then Result := tkKey else
      if KeyComp('ROLE') then Result := tkKey else
        if KeyComp('AFTER') then Result := tkKey else
          if KeyComp('SINH') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func51: TtkTokenKind;
begin
  if KeyComp('DBNLS') then Result := tkKey else
    if KeyComp('DBPATH') then Result := tkKey else
      if KeyComp('BEFORE') then Result := tkKey else
        if KeyComp('DELETE') then Result := tkKey else
          if KeyComp('FULL') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func52: TtkTokenKind;
begin
  if KeyComp('SOME') then Result := tkKey else
    if KeyComp('NAMES') then Result := tkKey else
      if KeyComp('BYTE') then Result := tkKey else
        if KeyComp('CREATE') then Result := tkKey else
          if KeyComp('INIT') then Result := tkKey else
            if KeyComp('NODEFDAC') then Result := tkKey else
              if KeyComp('FROM') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func53: TtkTokenKind;
begin
  if KeyComp('WAIT') then Result := tkKey else
    if KeyComp('DATABASE') then Result := tkKey else
      if KeyComp('DROP') then Result := tkKey else
        if KeyComp('DBTIME') then Result := tkKey else
          if KeyComp('SUM') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func54: TtkTokenKind;
begin
  if KeyComp('CLOSE') then Result := tkKey else
    if KeyComp('FLOAT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func55: TtkTokenKind;
begin
  if KeyComp('SHARED') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func56: TtkTokenKind;
begin
  if KeyComp('INDEX') then Result := tkKey else
    if KeyComp('LEVEL') then Result := tkKey else
      if KeyComp('SHELL') then Result := tkKey else
        if KeyComp('LOCATE') then Result := tkKey else
          if KeyComp('DOMAIN') then Result := tkKey else
            if KeyComp('OUT') then Result := tkKey else
              if KeyComp('ALTER') then Result := tkKey else
                if KeyComp('CONCAT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func57: TtkTokenKind;
begin
  if KeyComp('GOTO') then Result := tkKey else
    if KeyComp('ISQL') then Result := tkKey else
      if KeyComp('GDSCODE') then Result := tkKey else
        if KeyComp('AUTO') then Result := tkKey else
          if KeyComp('WHILE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func58: TtkTokenKind;
begin
  if KeyComp('BUFFER') then Result := tkKey else
    if KeyComp('INTO') then Result := tkKey else
      if KeyComp('EXIT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func59: TtkTokenKind;
begin
  if KeyComp('DOUBLE') then Result := tkKey else
    if KeyComp('NULL') then Result := tkKey else
      if KeyComp('CEILING') then Result := tkKey else
        if KeyComp('DBAPICODE') then Result := tkKey else
          if KeyComp('VIEW') then Result := tkKey else
            if KeyComp('WHERE') then Result := tkKey else
              if KeyComp('SIZE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func60: TtkTokenKind;
begin
  if KeyComp('WITH') then Result := tkKey else
    if KeyComp('GRANT') then Result := tkKey else
      if KeyComp('ORDER') then Result := tkKey else
        if KeyComp('ACTIVE') then Result := tkKey else
          if KeyComp('SECOND') then Result := tkKey else
            if KeyComp('TRIM') then Result := tkKey else
              if KeyComp('INNER') then Result := tkKey else
                if KeyComp('FOUND') then Result := tkKey else
                  if KeyComp('REPLACE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func61: TtkTokenKind;
begin
  if KeyComp('HAVING') then Result := tkKey else
    if KeyComp('VALUE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func62: TtkTokenKind;
begin
  if KeyComp('MANUAL') then Result := tkKey else
    if KeyComp('HOUR') then Result := tkKey else
      if KeyComp('ACTION') then Result := tkKey else
        if KeyComp('RIGHT') then Result := tkKey else
          if KeyComp('GRAPHIC') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func63: TtkTokenKind;
begin
  if KeyComp('COALESCE') then Result := tkKey else
    if KeyComp('USER') then Result := tkKey else
      if KeyComp('PUBLIC') then Result := tkKey else
        if KeyComp('DEGREES') then Result := tkKey else
          if KeyComp('DAYNAME') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func64: TtkTokenKind;
begin
  if KeyComp('SELECT') then Result := tkKey else
    if KeyComp('SERIAL') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func65: TtkTokenKind;
begin
  if KeyComp('PROCID') then Result := tkKey else
    if KeyComp('REPEAT') then Result := tkKey else
      if KeyComp('SHOW') then Result := tkKey else
        if KeyComp('RELEASE') then Result := tkKey else
          if KeyComp('DESCRIBE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func66: TtkTokenKind;
begin
  if KeyComp('TYPE') then Result := tkKey else
    if KeyComp('FLOOR') then Result := tkKey else
      if KeyComp('LENGTH') then Result := tkKey else
        if KeyComp('RADIANS') then Result := tkKey else
          if KeyComp('EVENT') then Result := tkKey else
            if KeyComp('SINGLE') then Result := tkKey else
              if KeyComp('ONLY') then Result := tkKey else
                if KeyComp('LOGFILE') then Result := tkKey else
                  if KeyComp('DBBLOBBUF') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func67: TtkTokenKind;
begin
  if KeyComp('WORK') then Result := tkKey else
    if KeyComp('UPDATE') then Result := tkKey else
      if KeyComp('QUIT') then Result := tkKey else
        if KeyComp('RETAIN') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func68: TtkTokenKind;
begin
  if KeyComp('DIGITS') then Result := tkKey else
    if KeyComp('COLLATE') then Result := tkKey else
      if KeyComp('LANGUAGE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func69: TtkTokenKind;
begin
  if KeyComp('TEXT') then Result := tkKey else
    if KeyComp('BLOBEDIT') then Result := tkKey else
      if KeyComp('MESSAGE') then Result := tkKey else
        if KeyComp('BINARY') then Result := tkKey else
          if KeyComp('DEFAULT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func70: TtkTokenKind;
begin
  if KeyComp('MONTH') then Result := tkKey else
    if KeyComp('VARIABLE') then Result := tkKey else
      if KeyComp('GEN_ID') then Result := tkKey else
        if KeyComp('USING') then Result := tkKey else
          if KeyComp('FILTER') then Result := tkKey else
            if KeyComp('SHADOW') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func71: TtkTokenKind;
begin
  if KeyComp('VARCHAR2') then Result := tkKey else
    if KeyComp('VARCHAR') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func72: TtkTokenKind;
begin
  if KeyComp('LTRIM') then Result := tkKey else
    if KeyComp('MONEY') then Result := tkKey else
      if KeyComp('SORT') then Result := tkKey else
        if KeyComp('ROUND') then Result := tkKey else
          if KeyComp('VARBIT') then Result := tkKey else
            if KeyComp('COLLCHAR') then Result := tkKey else
              if KeyComp('STATIC') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func73: TtkTokenKind;
begin
  if KeyComp('COUNT') then Result := tkKey else
    if KeyComp('LOWER') then Result := tkKey else
      if KeyComp('NUMBER') then Result := tkKey else
        if KeyComp('UNION') then Result := tkKey else
          if KeyComp('COMMIT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func74: TtkTokenKind;
begin
  if KeyComp('SQRT') then Result := tkKey else
    if KeyComp('ROLLBACK') then Result := tkKey else
      if KeyComp('CONNECT') then Result := tkKey else
        if KeyComp('ERROR') then Result := tkKey else
          if KeyComp('NULLIF') then Result := tkKey else
            if KeyComp('FOREIGN') then Result := tkKey else
              if KeyComp('BETWEEN') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func75: TtkTokenKind;
begin
  if KeyComp('WRITE') then Result := tkKey else
    if KeyComp('SQLCODE') then Result := tkKey else
      if KeyComp('DIFFERENCE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func76: TtkTokenKind;
begin
  if KeyComp('UPPER') then Result := tkKey else
    if KeyComp('ASCENDING') then Result := tkKey else
      if KeyComp('REVOKE') then Result := tkKey else
        if KeyComp('MLSLABEL') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func77: TtkTokenKind;
begin
  if KeyComp('POWER') then Result := tkKey else
    if KeyComp('GROUP') then Result := tkKey else
      if KeyComp('AUTODDL') then Result := tkKey else
        if KeyComp('DATETIME') then Result := tkKey else
          if KeyComp('CHARACTER') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func78: TtkTokenKind;
begin
  if KeyComp('ISOPEN') then Result := tkKey else
    if KeyComp('DB_KEY') then Result := tkKey else
      if KeyComp('INTEGER') then Result := tkKey else
        if KeyComp('INTEGER') then Result := tkKey else
          if KeyComp('COLUMN') then Result := tkKey else
            if KeyComp('RTRIM') then Result := tkKey else
              if KeyComp('DBMONEY') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func79: TtkTokenKind;
begin
  if KeyComp('PREPARE') then Result := tkKey else
    if KeyComp('OUTER') then Result := tkKey else
      if KeyComp('IMMEDIATE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func80: TtkTokenKind;
begin
  if KeyComp('INPUT') then Result := tkKey else
    if KeyComp('VALUES') then Result := tkKey else
      if KeyComp('SHORT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func81: TtkTokenKind;
begin
  if KeyComp('EXPLAIN') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func82: TtkTokenKind;
begin
  if KeyComp('MINUTE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func83: TtkTokenKind;
begin
  if KeyComp('SEGMENT') then Result := tkKey else
    if KeyComp('COMMENT') then Result := tkKey else
      if KeyComp('NUMERIC') then Result := tkKey else
        if KeyComp('EXECUTE') then Result := tkKey else
          if KeyComp('ONCONFIG') then Result := tkKey else
            if KeyComp('INACTIVE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func84: TtkTokenKind;
begin
  if KeyComp('TABLESPACE') then Result := tkKey else
    if KeyComp('TRIGGER') then Result := tkKey else
      if KeyComp('DESCENDING') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func85: TtkTokenKind;
begin
  if KeyComp('SECTION') then Result := tkKey else
    if KeyComp('INSERT') then Result := tkKey else
      if KeyComp('NVARCHAR') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func86: TtkTokenKind;
begin
  if KeyComp('DISPLAY') then Result := tkKey else
    if KeyComp('QUERY') then Result := tkKey else
      if KeyComp('EXTERN') then Result := tkKey else
        if KeyComp('NOAUTO') then Result := tkKey else
          if KeyComp('NATIONAL') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func87: TtkTokenKind;
begin
  if KeyComp('SERVER') then Result := tkKey else
    if KeyComp('DBUPSPACE') then Result := tkKey else
      if KeyComp('NATURAL') then Result := tkKey else
        if KeyComp('RESERV') then Result := tkKey else
          if KeyComp('UNIQUE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func89: TtkTokenKind;
begin
  if KeyComp('OPTION') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func90: TtkTokenKind;
begin
  if KeyComp('CSTRING') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func91: TtkTokenKind;
begin
  if KeyComp('EXTRACT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func92: TtkTokenKind;
begin
  if KeyComp('MINIMUM') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func93: TtkTokenKind;
begin
  if KeyComp('LC_TIME') then Result := tkKey else
    if KeyComp('INDICATOR') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func94: TtkTokenKind;
begin
  if KeyComp('FREE_IT') then Result := tkKey else
    if KeyComp('CURSOR') then Result := tkKey else
      if KeyComp('MAXIMUM') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func95: TtkTokenKind;
begin
  if KeyComp('DAYOFWEEK') then Result := tkKey else
    if KeyComp('PAGELENGTH') then Result := tkKey else
      if KeyComp('DELIMIDENT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func96: TtkTokenKind;
begin
  if KeyComp('RETURN') then Result := tkKey else
    if KeyComp('VARYING') then Result := tkKey else
      if KeyComp('EXISTS') then Result := tkKey else
        if KeyComp('TO_DATE') then Result := tkKey else
          if KeyComp('TO_CHAR') then Result := tkKey else
            if KeyComp('COUNTER') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func97: TtkTokenKind;
begin
  if KeyComp('COMPUTED') then Result := tkKey else
    if KeyComp('CONVERT') then Result := tkKey else
      if KeyComp('PARAMETER') then Result := tkKey else
        if KeyComp('STARTS') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func98: TtkTokenKind;
begin
  if KeyComp('REFERENCES') then Result := tkKey else
    if KeyComp('CLUSTER') then Result := tkKey else
      if KeyComp('DISTINCT') then Result := tkKey else
        if KeyComp('SUSPEND') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func99: TtkTokenKind;
begin
  if KeyComp('SUBSTR') then Result := tkKey else
    if KeyComp('CURRENT') then Result := tkKey else
      if KeyComp('CURRENT') then Result := tkKey else
        if KeyComp('EXTERNAL') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func100: TtkTokenKind;
begin
  if KeyComp('DAYOFYEAR') then Result := tkKey else
    if KeyComp('SMALLINT') then Result := tkKey else
      if KeyComp('RUNTIME') then Result := tkKey else
        if KeyComp('WHENEVER') then Result := tkKey else
          if KeyComp('QUARTER') then Result := tkKey else
            if KeyComp('PRIMARY') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func101: TtkTokenKind;
begin
  if KeyComp('COLLATION') then Result := tkKey else
    if KeyComp('INTERVAL') then Result := tkKey else
      if KeyComp('DBDELIMITER') then Result := tkKey else
        if KeyComp('SINGULAR') then Result := tkKey else
          if KeyComp('CONTINUE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func102: TtkTokenKind;
begin
  if KeyComp('SOUNDEX') then Result := tkKey else
    if KeyComp('TRUNCATE') then Result := tkKey else
      if KeyComp('COMMITTED') then Result := tkKey else
        if KeyComp('VERSION') then Result := tkKey else
          if KeyComp('DATEFIRST') then Result := tkKey else
            if KeyComp('FUNCTION') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func103: TtkTokenKind;
begin
  if KeyComp('GENERATOR') then Result := tkKey else
    if KeyComp('VARGRAPHIC') then Result := tkKey else
      if KeyComp('MONTHNAME') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func104: TtkTokenKind;
begin
  if KeyComp('TABLE_NAME') then Result := tkKey else
    if KeyComp('DBSPACETEMP') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func105: TtkTokenKind;
begin
  if KeyComp('PROCEDURE') then Result := tkKey else
    if KeyComp('DBANSIWARN') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func106: TtkTokenKind;
begin
  if KeyComp('PROTECTED') then Result := tkKey else
    if KeyComp('CONTAINING') then Result := tkKey else
      if KeyComp('IDENTITY') then Result := tkKey else
        if KeyComp('DISCONNECT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func107: TtkTokenKind;
begin
  if KeyComp('POSSTR') then Result := tkKey else
    if KeyComp('TIMEZONE') then Result := tkKey else
      if KeyComp('CURRENCY') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func108: TtkTokenKind;
begin
  if KeyComp('STARTING') then Result := tkKey else
    if KeyComp('PRECISION') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func109: TtkTokenKind;
begin
  if KeyComp('TIMETICKS') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func110: TtkTokenKind;
begin
  if KeyComp('TRANSLATE') then Result := tkKey else
    if KeyComp('VARBINARY') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func111: TtkTokenKind;
begin
  if KeyComp('NODENUMBER') then Result := tkKey else
    if KeyComp('TINYINT') then Result := tkKey else
      if KeyComp('EXCEPTION') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func112: TtkTokenKind;
begin
  if KeyComp('SNAPSHOT') then Result := tkKey else
    if KeyComp('LC_TYPE') then Result := tkKey else
      if KeyComp('RESTRICT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func113: TtkTokenKind;
begin
  if KeyComp('OUTPUT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func114: TtkTokenKind;
begin
  if KeyComp('LC_COLLATE') then Result := tkKey else
    if KeyComp('HEXTORAW') then Result := tkKey else
      if KeyComp('ISOLATION') then Result := tkKey else
        if KeyComp('NESTLEVEL') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func115: TtkTokenKind;
begin
  if KeyComp('NODEGROUP') then Result := tkKey else
    if KeyComp('LC_CTYPE') then Result := tkKey else
      if KeyComp('RETURNS') then Result := tkKey else
        if KeyComp('PASSWORD') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func116: TtkTokenKind;
begin
  if KeyComp('CONDITIONAL') then Result := tkKey else
    if KeyComp('OVERFLOW') then Result := tkKey else
      if KeyComp('BUFFERPOOL') then Result := tkKey else
        if KeyComp('TIMESTAMP') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func117: TtkTokenKind;
begin
  if KeyComp('RESERVING') then Result := tkKey else
    if KeyComp('POSITION') then Result := tkKey else
      if KeyComp('LONGBINARY') then Result := tkKey else
        if KeyComp('STABILITY') then Result := tkKey else
          if KeyComp('STATEMENT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func118: TtkTokenKind;
begin
  if KeyComp('MICROSECOND') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func119: TtkTokenKind;
begin
  if KeyComp('PAGE_SIZE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func120: TtkTokenKind;
begin
  if KeyComp('TABLE_SCHEMA') then Result := tkKey else
    if KeyComp('SERVERNAME') then Result := tkKey else
      if KeyComp('PACK_SENT') then Result := tkKey else
        if KeyComp('COMPILETIME') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func122: TtkTokenKind;
begin
  if KeyComp('PRIVILEGES') then Result := tkKey else
    if KeyComp('PARTITION') then Result := tkKey else
      if KeyComp('ROWTYPE') then Result := tkKey else
        if KeyComp('SQLERROR') then Result := tkKey else
          if KeyComp('IO_BUSY') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func123: TtkTokenKind;
begin
  if KeyComp('REMSERVER') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func126: TtkTokenKind;
begin
  if KeyComp('TRANCOUNT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func127: TtkTokenKind;
begin
  if KeyComp('DESCRIPTOR') then Result := tkKey else
    if KeyComp('TOTAL_READ') then Result := tkKey else
      if KeyComp('CHAR_LENGTH') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func128: TtkTokenKind;
begin
  if KeyComp('BIT_LENGTH') then Result := tkKey else
    if KeyComp('JULIAN_DAY') then Result := tkKey else
      if KeyComp('TEXTSIZE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func129: TtkTokenKind;
begin
  if KeyComp('SUBSTRING') then Result := tkKey else
    if KeyComp('SMALLMONEY') then Result := tkKey else
      if KeyComp('LC_NUMERIC') then Result := tkKey else
        if KeyComp('CONTROLFILE') then Result := tkKey else
          if KeyComp('ROWCOUNT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func131: TtkTokenKind;
begin
  if KeyComp('CONNECTIONS') then Result := tkKey else
    if KeyComp('WAIT_TIME') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func133: TtkTokenKind;
begin
  if KeyComp('PACK_RECEIVED') then Result := tkKey else
    if KeyComp('TERMINATOR') then Result := tkKey else
      if KeyComp('CONSTRAINT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func134: TtkTokenKind;
begin
  if KeyComp('LC_MESSAGES') then Result := tkKey else
    if KeyComp('SMALLDATETIME') then Result := tkKey else
      if KeyComp('SQLWARNING') then Result := tkKey else
        if KeyComp('MODULE_NAME') then Result := tkKey else
          if KeyComp('TRANSACTION') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func137: TtkTokenKind;
begin
  if KeyComp('UNCOMMITTED') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func138: TtkTokenKind;
begin
  if KeyComp('CPU_BUSY') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func139: TtkTokenKind;
begin
  if KeyComp('SUB_TYPE') then Result := tkKey else
    if KeyComp('STATISTICS') then Result := tkKey else
      if KeyComp('INFORMIXDIR') then Result := tkKey else
        if KeyComp('TO_NUMBER') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func141: TtkTokenKind;
begin
  if KeyComp('TIMESTAMPDIFF') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func143: TtkTokenKind;
begin
  if KeyComp('TRANSLATION') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func150: TtkTokenKind;
begin
  if KeyComp('LONG_VARCHAR') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func152: TtkTokenKind;
begin
  if KeyComp('MAX_SEGMENT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func157: TtkTokenKind;
begin
  if KeyComp('LC_MONETARY') then Result := tkKey else
    if KeyComp('SHORTDATETIME') then Result := tkKey else
      if KeyComp('RAISE_ERROR') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func160: TtkTokenKind;
begin
  if KeyComp('OCTET_LENGTH') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func167: TtkTokenKind;
begin
  if KeyComp('POST_EVENT') then Result := tkKey else
    if KeyComp('OPTIMIZATION') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func173: TtkTokenKind;
begin
  if KeyComp('FETCH_STATUS') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func174: TtkTokenKind;
begin
  if KeyComp('CHARACTER_LENGTH') then Result := tkKey else
    if KeyComp('TOTAL_WRITE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func177: TtkTokenKind;
begin
  if KeyComp('INPUT_TYPE') then Result := tkKey else
    if KeyComp('MAX_PRECISION') then Result := tkKey else
      if KeyComp('CURRENT_TIME') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func180: TtkTokenKind;
begin
  if KeyComp('PACKET_ERRORS') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func181: TtkTokenKind;
begin
  if KeyComp('FET_BUF_SIZE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func182: TtkTokenKind;
begin
  if KeyComp('LONG_VARGRAPHIC') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func184: TtkTokenKind;
begin
  if KeyComp('LOG_BUF_SIZE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func187: TtkTokenKind;
begin
  if KeyComp('ENTRY_POINT') then Result := tkKey else
    if KeyComp('INFORMIXCONTIME') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func190: TtkTokenKind;
begin
  if KeyComp('TIMESTAMP_ISO') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func192: TtkTokenKind;
begin
  if KeyComp('NUM_LOG_BUFS') then Result := tkKey else
    if KeyComp('TOTAL_ERRORS') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func193: TtkTokenKind;
begin
  if KeyComp('CURRENT_USER') then Result := tkKey else
    if KeyComp('GENERATE_UNIQUE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func194: TtkTokenKind;
begin
  if KeyComp('MIDNIGHT_SECONDS') then Result := tkKey else
    if KeyComp('SESSION_USER') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func195: TtkTokenKind;
begin
  if KeyComp('SYSTEM_USER') then Result := tkKey else
    if KeyComp('INFORMIXSERVER') then Result := tkKey else
      if KeyComp('INFORMIXSERVER') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func196: TtkTokenKind;
begin
  if KeyComp('RECORD_VERSION') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func197: TtkTokenKind;
begin
  if KeyComp('CHECK_POINT_LEN') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func200: TtkTokenKind;
begin
  if KeyComp('MAX_CONNECTIONS') then Result := tkKey else
    if KeyComp('CURSOR_ROWS') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func208: TtkTokenKind;
begin
  if KeyComp('MAXIMUM_SEGMENT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func210: TtkTokenKind;
begin
  if KeyComp('OUTPUT_TYPE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func212: TtkTokenKind;
begin
  if KeyComp('GROUP_COMMIT_') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func213: TtkTokenKind;
begin
  if KeyComp('LOG_BUFFER_SIZE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func214: TtkTokenKind;
begin
  if KeyComp('RAW_PARTITIONS') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func215: TtkTokenKind;
begin
  if KeyComp('TO_SINGLE_BYTE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func220: TtkTokenKind;
begin
  if KeyComp('MICROSOFTVERSION') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func221: TtkTokenKind;
begin
  if KeyComp('NUM_LOG_BUFFERS') then Result := tkKey else
    if KeyComp('INFORMIXSTACKSIZE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func224: TtkTokenKind;
begin
  if KeyComp('TO_MULTI_BYTE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func226: TtkTokenKind;
begin
  if KeyComp('INFORMIXCONRETRY') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func232: TtkTokenKind;
begin
  if KeyComp('CHECK_POINT_LENGTH') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func235: TtkTokenKind;
begin
  if KeyComp('EVENT_MON_STATE') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func237: TtkTokenKind;
begin
  if KeyComp('RETURNING_VALUES') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func244: TtkTokenKind;
begin
  if KeyComp('TO_BINARY_INTEGER') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func246: TtkTokenKind;
begin
  if KeyComp('CURRENT_TIMESTAMP') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.Func265: TtkTokenKind;
begin
  if KeyComp('GROUP_COMMIT_WAIT') then Result := tkKey else Result := tkIdentifier;
end;

function TvvSqlSyn.AltFunc: TtkTokenKind;
begin
  Result := tkIdentifier;
end;

function TvvSqlSyn.IdentKind(MayBe: PChar): TtkTokenKind;
var
  HashKey: Integer;
begin
  fToIdent := MayBe;
  HashKey := KeyHash(MayBe);
  if HashKey < 266 then Result := fIdentFuncTable[HashKey] else Result := tkIdentifier;
end;

procedure TvvSqlSyn.MakeMethodTables;
var
  I: Char;
begin
  for I := #0 to #255 do
    case I of
      '&': fProcTable[I] := AmpersandProc;
      '}': fProcTable[I] := BraceCloseProc;
      '{': fProcTable[I] := BraceOpenProc;
      #13: fProcTable[I] := CRProc;
      ':': fProcTable[I] := ColonProc;
      ',': fProcTable[I] := CommaProc;
      '=': fProcTable[I] := EqualProc;
      '^': fProcTable[I] := ExponentiationProc;
      '>': fProcTable[I] := GreaterProc;
      'A'..'Z', 'a'..'z', '_': fProcTable[I] := IdentProc;
      #10: fProcTable[I] := LFProc;
      '<': fProcTable[I] := LowerProc;
      '-': fProcTable[I] := MinusProc;
      #0: fProcTable[I] := NullProc;
      '0'..'9': fProcTable[I] := NumberProc;
      '%': fProcTable[I] := PercentProc;
      '|': fProcTable[I] := PipeProc;
      '+': fProcTable[I] := PlusProc;
      '.': fProcTable[I] := PointProc;
      '?': fProcTable[I] := QuestionProc;
      ')': fProcTable[I] := RoundCloseProc;
      '(': fProcTable[I] := RoundOpenProc;
      ';': fProcTable[I] := SemiColonProc;
      '/': fProcTable[I] := SlashProc;
      #1..#9, #11, #12, #14..#32: fProcTable[I] := SpaceProc;
      '*': fProcTable[I] := StarProc;
      #39: fProcTable[I] := StringProc;
    else fProcTable[I] := UnknownProc;
    end;
end;

constructor TvvSqlSyn.Create(AOwner: TComponent);
begin
  fCommentAttri := TmwHighLightAttributes.Create(MWS_AttrComment);
  fIdentifierAttri := TmwHighLightAttributes.Create(MWS_AttrIdentifier);
  fKeyAttri := TmwHighLightAttributes.Create(MWS_AttrReservedWord);
  fNumberAttri := TmwHighLightAttributes.Create(MWS_AttrNumber);
  fParametrAttri := TmwHighLightAttributes.Create('Parametr');
  fMacrosAttri := TmwHighLightAttributes.Create('Macros');
  fIllegalAttri := TmwHighLightAttributes.Create('Illegal');
  fSpaceAttri := TmwHighLightAttributes.Create(MWS_AttrSpace);
  fStringAttri := TmwHighLightAttributes.Create(MWS_AttrString);
  fSymbolAttri := TmwHighLightAttributes.Create(MWS_AttrSymbol);
  inherited Create(AOwner);
  AddAttribute(fCommentAttri);
  AddAttribute(fIdentifierAttri);
  AddAttribute(fKeyAttri);
  AddAttribute(fNumberAttri);
  AddAttribute(fParametrAttri);
  AddAttribute(fMacrosAttri);
  AddAttribute(fIllegalAttri);
  AddAttribute(fSpaceAttri);
  AddAttribute(fStringAttri);
  AddAttribute(fSymbolAttri);
  SetAttributesOnChange(DefHighlightChange);
  InitIdent;
  MakeMethodTables;
  fDefaultFilter := MWS_FilterSQL;
  fRange := rsUnknown;
end;

procedure TvvSqlSyn.SetLine(NewValue: String; LineNumber: Integer);
begin
  fLine := PChar(NewValue);
  Run := 0;
  fLineNumber := LineNumber;
  Next;
end;

procedure TvvSqlSyn.AmpersandProc;
begin
  inc(Run);
  fTokenId := tkSymbol;
end;

procedure TvvSqlSyn.BraceCloseProc;
begin
  inc(Run);
  fTokenId := tkSymbol;
end;

procedure TvvSqlSyn.BraceOpenProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
end;

procedure TvvSqlSyn.CRProc;
begin
  fTokenID := tkSpace;
  Case FLine[Run + 1] of
    #10: inc(Run, 2);
  else inc(Run);
  end;
end;

procedure TvvSqlSyn.ColonProc;
begin
  {inc(Run);
  fTokenID := tkSymbol;}

  fTokenID := tkParametr;
  while FLine[Run] <> #0 do
  begin
    case FLine[Run] of
      #10, #13, ' ', ',' ,')' : break;
    end;
    inc(Run);
  end;
end;

procedure TvvSqlSyn.CommaProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
end;

procedure TvvSqlSyn.EqualProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
end;

procedure TvvSqlSyn.ExponentiationProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
end;

procedure TvvSqlSyn.GreaterProc;
begin
  Case FLine[Run + 1] of
    '=':
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TvvSqlSyn.IdentProc;
begin
  fTokenID := IdentKind((fLine + Run));
  inc(Run, fStringLen);
  while Identifiers[fLine[Run]] do inc(Run);
end;

procedure TvvSqlSyn.LFProc;
begin
  fTokenID := tkSpace;
  inc(Run);
end;

procedure TvvSqlSyn.LowerProc;
begin
  case FLine[Run + 1] of
    '=':
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
    '>':
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end
  else
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;
end;

procedure TvvSqlSyn.MinusProc;
begin
  case FLine[Run + 1] of
    '-' :
      begin
        inc(Run, 2);
        fTokenID := tkComment;
        while FLine[Run] <> #0 do
          begin
            case FLine[Run] of
              #10, #13 : break;
            end;
            inc(Run);
          end;
      end;
    else
      begin
        inc(Run);
        fTokenID := tkSymbol;
      end;
  end;
end;

procedure TvvSqlSyn.NullProc;
begin
  fTokenID := tkNull;
end;

procedure TvvSqlSyn.NumberProc;
begin
  inc(Run);
  fTokenID := tkNumber;
  while FLine[Run] in ['0'..'9', '.', 'e', 'E'] do
    inc(Run);
end;

procedure TvvSqlSyn.MacrosProc;
begin
  inc(Run);
  while FLine[Run] <> #0 do
  begin
    case FLine[Run] of
      #10, #13, ' ', ',' ,')' :
        begin
        fTokenID := tkIllegal;
        break;
        end;
      '%':
        if FLine[Run+1]='%' then
        begin
        inc(Run, 2);
        fTokenID := tkMacros;
        break;
        end;
    end;
    inc(Run);
  end;
  if fRange=rsMacrosInStr then fRange:=rsEndStrAfterMacr;
end;


procedure TvvSqlSyn.PercentProc;
begin
  if FLine[Run+1]='%' then// %% -> macros
   MacrosProc
  else
   begin
     fTokenID := tkSymbol;
     inc(Run);
   end;
end;

procedure TvvSqlSyn.PipeProc;
begin
  Case FLine[Run + 1] of
    '|':                   {concatenation}
      begin
        inc(Run, 2);
        fTokenID := tkSymbol;
      end;
  else
    begin
      inc(Run);
      fTokenID := tkIdentifier;
    end;
  end;
end;

procedure TvvSqlSyn.PlusProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
end;

procedure TvvSqlSyn.PointProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
end;

procedure TvvSqlSyn.QuestionProc;
begin
  fTokenID := tkSymbol;
  inc(Run);
end;

procedure TvvSqlSyn.RoundCloseProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
end;

procedure TvvSqlSyn.RoundOpenProc;
begin
  inc(Run);
  FTokenID := tkSymbol;
end;

procedure TvvSqlSyn.SemiColonProc;
begin
  inc(Run);
  fTokenID := tkSymbol;
end;

procedure TvvSqlSyn.SlashProc;
begin
  case FLine[Run + 1] of
    {'/':                               //c++ style comments
      begin
        inc(Run, 2);
        fTokenID := tkComment;
        while FLine[Run] <> #0 do
        begin
          case FLine[Run] of
            #10, #13: break;
          end;
          inc(Run);
        end;
      end;}
    '*':                               //c style comments
      begin
        fTokenID := tkComment;
        fRange := rsAnsiC;   //kuzn_vv
        inc(Run);
        while fLine[Run] <> #0 do
        begin 
          if (fLine[Run]='*') and
             (fLine[Run + 1] = '/') then
          begin
            inc(Run, 2);
            fRange := rsUnKnown;  //kuzn_vv
            break;
          end 
          else 
            inc(Run);
        end;
      end; 
  else                                 //division
    begin
      inc(Run);
      fTokenID := tkSymbol;
    end;
  end;

end;

procedure TvvSqlSyn.SpaceProc;
begin
  inc(Run);
  fTokenID := tkSpace;
  while FLine[Run] in [#1..#9, #11, #12, #14..#32] do inc(Run);
end;

procedure TvvSqlSyn.StarProc;
begin
  case FLine[Run + 1] of
    '/':                     {end comment}
      begin
        fTokenID := tkComment;
        fRange   := rsANil;
        inc(Run, 2);
      end;
    else
      begin
        inc(Run);            {multi}
        fTokenID := tkSymbol;
      end;
  end;
end;

procedure TvvSqlSyn.StringProc;
begin
  fTokenID := tkString;
  repeat
    case FLine[Run] of
      #0, #10, #13: break;
    end;

    if (FLine[Run]='%') and
       (FLine[Run+1]='%') then // %% -> macros
    begin
      dec(Run);
      fRange := rsMacrosInStr;
      break;
    end;

    inc(Run);
  until FLine[Run] = #39;
  if FLine[Run] <> #0 then inc(Run);

end;


{procedure TvvSqlSyn.StringProc;
begin
  fTokenID := tkString;
  repeat
    case FLine[Run] of
      #0, #10, #13: break;
    end;
    inc(Run);
  until FLine[Run] = #39;
  if FLine[Run] <> #0 then inc(Run);
end;}

procedure TvvSqlSyn.UnknownProc;
begin
  inc(Run);
  fTokenID := tkUnknown;
end;

//kuzn_vv
procedure TvvSQLSyn.AnsiCProc;
begin
  fTokenID := tkComment;
  case FLine[Run] of
    #0:
      begin
        NullProc;
        exit;
      end;
    #10:
      begin
        LFProc;
        exit;
      end;
    #13:
      begin
        CRProc;
        exit;
      end;
  end;

  while FLine[Run] <> #0 do
    case FLine[Run] of
      '*':
        if fLine[Run + 1] = '/' then
        begin
          inc(Run, 2);
          fRange := rsUnKnown;
          break;
        end
        else inc(Run);
      #10: break;
      #13: break;
    else inc(Run);
    end;
end;


procedure TvvSQLSyn.EndStrAfterMacros;
begin
  fTokenID := tkString;
  fRange := rsUnKnown;

  while FLine[Run] <> #0 do
  begin
    case FLine[Run] of
      #10, #13: break;
      #39: begin inc(Run); break; end;
    end;
    inc(Run);
  end;
end;

procedure TvvSqlSyn.Next;
begin
  fTokenPos := Run;
  //kuzn_vv
  Case fRange of
    rsAnsiC: AnsiCProc;
    rsMacrosInStr: MacrosProc;
    rsEndStrAfterMacr: EndStrAfterMacros;
    else
      fRange := rsUnknown;
      fProcTable[fLine[Run]];
  end;
end;

function TvvSqlSyn.GetEOL: Boolean;
begin
  Result := fTokenID = tkNull;
end;

function TvvSqlSyn.GetRange: Pointer;
begin
  Result := Pointer(fRange);
end;

function TvvSqlSyn.GetToken: String;
var
  Len: LongInt;
begin
  Len := Run - fTokenPos;
  SetString(Result, (FLine + fTokenPos), Len);
end;

function TvvSqlSyn.GetTokenID: TtkTokenKind;
begin
  Result := fTokenId;
end;

function TvvSqlSyn.GetTokenAttribute: TmwHighLightAttributes;
begin
  case GetTokenID of
    tkComment: Result := fCommentAttri;
    tkIdentifier: Result := fIdentifierAttri;
    tkKey: Result := fKeyAttri;
    tkNumber: Result := fNumberAttri;
    tkParametr: Result := fParametrAttri;
    tkMacros: Result := fMacrosAttri;
    tkIllegal: Result := fIllegalAttri;
    tkSpace: Result := fSpaceAttri;
    tkString: Result := fStringAttri;
    tkSymbol: Result := fSymbolAttri;
    tkUnknown: Result := fIdentifierAttri;
  else Result := nil;
  end;
end;

function TvvSqlSyn.GetTokenKind: integer;
begin
  Result := Ord(fTokenId);
end;

function TvvSqlSyn.GetTokenPos: Integer;
begin
  Result := fTokenPos;
end;

procedure TvvSqlSyn.ReSetRange;
begin
  fRange := rsUnknown;
end;

procedure TvvSqlSyn.SetRange(Value: Pointer);
begin
  fRange := TRangeState(Value);
end;

function TvvSqlSyn.GetIdentChars: TIdentChars;
begin
  Result := ['_', '0'..'9', 'a'..'z', 'A'..'Z'];
end;

function TvvSqlSyn.GetLanguageName: string;
begin
  Result := MWS_LangSQL;
end;

function TvvSqlSyn.GetCapability: THighlighterCapability;
begin
  Result := inherited GetCapability + [hcUserSettings, hcExportable];
end;

procedure TvvSqlSyn.SetLineForExport(NewValue: String);
begin
  fLine := PChar(NewValue);
  Run := 0;
  ExportNext;
end;

procedure TvvSqlSyn.ExportNext;
begin
  fTokenPos := Run;
  fProcTable[fLine[Run]];
  if Assigned(Exporter) then
    with TmwCustomExport(Exporter) do
    begin
      Case GetTokenID of
        tkComment:    FormatToken(GetToken, fCommentAttri, True, False);
        tkIdentifier: FormatToken(GetToken, fIdentifierAttri, False, False);
        tkKey:        FormatToken(GetToken, fKeyAttri, False, False);
        tkNumber:     FormatToken(GetToken, fNumberAttri, False, False);
        tkNull:       FormatToken('', nil, False,False);
        tkParametr:   FormatToken(GetToken, fParametrAttri, False, False);
        tkMacros:     FormatToken(GetToken, fMacrosAttri, False, False);
        tkIllegal:    FormatToken(GetToken, fIllegalAttri, False, False);
        tkSpace:      FormatToken(GetToken, fSpaceAttri, False, True);
        tkString:     FormatToken(GetToken, fStringAttri, True, False);
        tkSymbol:     FormatToken(GetToken, fSymbolAttri, True, False);
      end;
    end;
end;

Initialization
  MakeIdentTable;
end.
